<!-- balance 余额明细 -->
<template>
    <div>
<!--        <div class="mb20">-->

<!--            <el-form ref="form" :model="form" label-width="120px">-->
<!--                <el-form-item label="选择用户">-->
<!--                    <el-select v-model="form.user" placeholder="选择用户">-->
<!--                        <el-option v-for="sell in sellers" :label="sell.admin.name" :value="sell.admin.id"></el-option>-->
<!--                    </el-select>-->
<!--                </el-form-item>-->

<!--                <el-form-item label="退款金额">-->
<!--                    <el-input type="number" placeholder="退款金额" v-model="form.amount"></el-input>-->
<!--                </el-form-item>-->
<!--                <el-form-item label="退还银行">-->
<!--                    <el-input placeholder="退还银行" v-model="form.bank"></el-input>-->
<!--                </el-form-item>-->
<!--                <el-form-item label="银行账户号码">-->
<!--                    <el-input placeholder="银行账户号码" v-model="form.account_number"></el-input>-->
<!--                </el-form-item>-->
<!--                <el-form-item label="银行账户持有人姓名">-->
<!--                    <el-input placeholder="银行账户持有人姓名" v-model="form.account_holder_name"></el-input>-->
<!--                </el-form-item>-->
<!--                <el-upload class="avatar-uploader" :action="m_action" :show-file-list="false" name="images"-->
<!--                           :with-credentials="true" :on-success="handleAvatarSuccess">-->

<!--                    <img v-if="form.img_url" :src="form.img_url" class="avatar" style="max-width:200px">-->
<!--                    <div v-else-->
<!--                         style="width:80px; background-color:#304156; height:20px; padding-top:6px; border-radius:20px;">-->
<!--                        <i style="color:white" class="el-icon-plus avatar-uploader-icon"></i>-->
<!--                    </div>-->

<!--                </el-upload>-->
<!--                <el-form-item>-->
<!--                    <el-button type="primary" @click="Refund">返还押金</el-button>-->
<!--                </el-form-item>-->
<!--            </el-form>-->

<!--        </div>-->

        <h3>交易次数</h3>
        <el-table
                :data="tableData"
                height="250"
                style="width: 100%">
            <el-table-column
                    prop="admin.name"
                    label="用户"
                    width="180">
            </el-table-column>
            <el-table-column
                    prop="original_total"
                    label="量"
                    width="180">
            </el-table-column>
            <el-table-column
                    prop="created_at"
                    label="日期"
                    width="180">
            </el-table-column>
            <el-table-column
                    label="行动"
                    width="300">
                <template slot-scope="scope">
                    <div v-if="scope.row.status == 4"> 已退款</div>
                    <el-button v-if="scope.row.status == 5" type="primary" @click="refundDepositRequest(scope.row)">
                        退款
                    </el-button>
                </template>
            </el-table-column>
        </el-table>

        <el-dialog title="申请退款" :visible.sync="dialogFormVisible">
            <el-form :model="form">
                <el-upload class="avatar-uploader" :action="m_action" :show-file-list="false" name="images"
                           :with-credentials="true" :on-success="handleAvatarSuccess">
                    <img v-if="form.img_url" :src="form.img_url" class="avatar" style="max-width:200px">
                    <div v-else
                         style="width:80px; background-color:#304156; height:20px; padding-top:6px; border-radius:20px;">
                        <i style="color:white" class="el-icon-plus avatar-uploader-icon"></i>
                    </div>
                    <span> 退款额度 : {{withdrawData.amount}} </span> <br>
                    <span> 所属银行 : {{withdrawData.bank_name}} </span> <br>
                    <span> 银行号码 : {{withdrawData.bank_account_no}} </span>
                    <span> 银行持有人姓名 : {{withdrawData.bank_account_holder_name}} </span>

                </el-upload>
            </el-form>
            <span slot="footer" class="dialog-footer">
                <el-button @click="dialogFormVisible = false">关</el-button>
                <el-button type="primary" @click="confirmWithdraw()">确认</el-button>
            </span>
        </el-dialog>

    </div>


</template>


<script>
    import * as api from '@/api'
    import axios from '../../components/downloadFile/axios'

    export default {
        name: 'refund',
        data() {
            return {
                dialogFormVisible: false,
                form: {
                    user: '',
                    amount: '',
                    bank: '',
                    account_number: '',
                    account_holder_name: '',
                    img_url: '',
                    order_id: '',
                    complete_deposit_request: '',
                    user_id: ''
                },
                withdrawData: {
                    bank_name: '',
                    bank_no: '',
                    bank_account_no: '',
                    bank_holder: '',
                },
                sellers: [],
                radio: 0,
                search_data: {
                    search: '',
                    type: '',
                    start_end: []
                },
                formData: {
                    amount: '',
                    img_url: '',
                },
                m_show: false,
                m_showForm: false,
                image: '',
                id: '',
                'userInfo': '',
                tableData: [],
            }
        },
        created() {
            this.init()
        },
        methods: {
            //初始化方法
            init() {
                this.userInfo = sessionStorage.userInfo && JSON.parse(sessionStorage.userInfo) || {};
                console.log(this.userInfo);
                this.getData();
                this.getSellers();
            },
            handleAvatarSuccess(res, file) {
                this.form.img_url = res.data;
                console.log(res, file)
            },
            getData() {
                api.seller_transactions_all({
                    'user_id': this.userInfo.id
                }).then(res => {
                    console.log(res.data);
                    this.tableData = res.data

                }).finally(() => {
                    this.m_tableLoading = false
                })
            },
            getSellers() {
                api.get_all_sellers({
                    'user_id': this.userInfo.id
                }).then(res => {
                    console.log('sellers ');
                    console.log(res.data);
                    this.sellers = res.data;
                }).finally(() => {
                    this.m_tableLoading = false
                })
            },
            Refund() {
                console.log('refund now');
                let that = this;
                api.refund_seller({
                    'user_id': this.form.user,
                    'amount': this.form.amount,
                    'bank_name': this.form.bank,
                    'bank_account_no': this.form.account_number,
                    'bank_account_holder_name': this.form.account_holder_name,
                    'complete_deposit_request': 0
                }).then(res => {
                    console.log(res);
                    this.m_success('已批准');
                    that.form.user = '';
                    that.form.amount = '';
                    that.form.bank = '';
                    that.form.account_number = '';
                    that.form.account_holder_name = '';
                }).finally(() => {
                    this.m_tableLoading = false
                })
            },
            refundDepositRequest(order) {
                console.log(order);
                this.dialogFormVisible = true;
                this.form.order_id = order.id;
                this.form.complete_deposit_request = 1;
                this.form.user_id = 0;
                this.withdrawData = order.seller_refund_request;
            },
            confirmWithdraw() {
                console.log(this.form);
                api.refund_seller(this.form).then(res => {
                    console.log(res);
                    this.m_success('已批准');
                    this.dialogFormVisible = false;
                    this.init();
                }).finally(() => {
                    this.m_tableLoading = false
                })
            },
            getRank() {
                let rank = this.userInfo.seller.rank_id;
                if (rank == 0) {
                    return 'DEFAULT';
                }
                if (rank == 1) {
                    return '个人商户';
                }
                if (rank == 2) {
                    return '当前商户类型';
                }
            },
            getAmount(cb) {
                let rank = this.userInfo.seller.rank_id;
                let upgradeRank = this.radio;
                if (rank == 0) {
                    if (upgradeRank == 1) {
                        cb({
                            amount: 2000,
                            message: '',
                            rank: upgradeRank
                        });
                    }
                    if (upgradeRank == 2) {
                        cb({
                            amount: 20000,
                            message: '',
                            rank: upgradeRank
                        });
                    }
                }
                if (rank == 1) {
                    if (upgradeRank == 1) {
                        cb({
                            amount: 0,
                            message: 'already on same rank',
                            rank: upgradeRank
                        });
                    }
                    if (upgradeRank == 2) {
                        cb({
                            amount: 18000,
                            message: 'already on same rank',
                            rank: upgradeRank
                        });
                    }
                }
                if (rank == 2) {
                    if (upgradeRank == 1) {
                        cb({
                            amount: 0,
                            message: 'downgrade',
                            rank: upgradeRank
                        });
                    }
                    if (upgradeRank == 2) {
                        cb({
                            amount: 0,
                            message: 'already on same rank',
                            rank: upgradeRank
                        });
                    }
                }

                return {
                    amount: 0,
                    message: 'something is fishy'
                }
            },
            m_pay() {
                console.log('PPPP');
                console.log(this.userInfo);
                let that = this;
                this.getAmount(function (am) {
                    console.log('am');
                    console.log(am.amount);
                    if (am.amount < 1) {
                        alert(am.message);
                    } else {
                        api.generate_seller_order({
                            'user_id': that.userInfo.id,
                            'amount': am.amount
                        }).then(res => {
                            if (res.code == 0) {
                                console.log('in pay order now');
                                let ob = {
                                    order_id: res.data.id,
                                    user_id: that.userInfo.id,
                                    rank_id: am.rank
                                };
                                console.log(ob);
                                let config = {
                                    headers: {
                                        'Authorization': `Bearer ${sessionStorage.token}`,
                                    }
                                };
                                api.pay_order_seller(ob, config).then(res => {
                                    console.log('res');
                                    console.log(res);
                                    setTimeout(() => {
                                        that.userInfo['seller']['rank_id'] = am.rank;
                                        window.location.assign(res.data)
                                    }, 1000);
                                    return res
                                }).finally((err) => {
                                    console.log('err');
                                    console.log(err);
                                })
                            }

                        }).finally((err) => {
                            console.log(err);
                        })
                    }
                });


            }
        },
    }

</script>
<style lang='scss' scoped>
</style>